/**********************************************************************************************
 * This example code is provided for illustrative purposes only and provided 'AS IS' without 
 * warranty of any kind.
 * 
 * Copyright ©2014 Chrysler Group LLC.  All Rights Reserved.  All information contained herein is,
 * and remains the property of Chrysler Group LLC and its suppliers, if any.  The intellectual and
 * technical concepts contained herein are proprietary to Chrysler Group LLC and its suppliers
 * and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secret or copyright law. Dissemination of this information or reproduction of this material is
 * strictly forbidden unless prior written permission is obtained from Chrysler Group LLC.
 *
 * Chrysler, Jeep, Dodge, Ram, SRT, Mopar and the Pentastar logo are registered trademarks of
 * Chrysler Group LLC. FIAT is a registered trademark of Fiat group Marketing & Corporate
 * Communication S.p.A. used under license by Chrysler Group LLC.
 *********************************************************************************************/
package com.fca.uconnect.global;

import com.amazonaws.services.iot.client.AWSIotException;
import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotMqttClient;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;
import com.fca.uconnect.global.GlobalUconnectControl.Location;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectAny;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectMessage;
import com.fca.uconnect.global.GlobalUconnectExtVehicleFinder.VehicleLocationRequest;
import com.fca.uconnect.global.GlobalUconnectExtVehicleFinder.VehicleLocationResponse;
import com.fca.uconnect.global.GlobalUconnectExtVehicleFinder.VehicleLocationResponse.VehicleLocationResponseEnum;
import com.google.protobuf.ExtensionRegistry;

/**
 * This example class demonstrates how to use the AWS IoT mqtt client to send/receive a Uconnect StolenVehicleAssistance messages to the SDP and wait for a response message.   
 * This code is only for reference and is furnished without warranty.....
 * 
 * @author FCA Global V2C API Team
 *
 */
public class TBMExampleForVehicleFinder {

	private String clientId; // The clientId is unique to the device and obtained from the client X.509 certificate CN.
	private int messageId; // The messageId is a sequential number incremented and assigned to each message sent from the client.
	private AWSIotMqttClient mqttClient; // The mqtt client object from the AWS IoT client library. 
	private AWSIotTopic iotTopic; // The Topic object to subscribe for inbound messages.
	private ExtensionRegistry extRegistry; // Google protocol buffers extension registry instance.
	private int correlationId = 0;// The correlationId is a sender messageId so that Sender can recognize the message once its received response.

	/**
	 * Constructor - initialize protocol buffer extension registry for parsing incoming Uconnect Messages.
	 */
	public TBMExampleForVehicleFinder() {
		extRegistry = ExtensionRegistry.newInstance();
		extRegistry.add(GlobalUconnectExtVehicleFinder.vehicleLocationRequest);
	}
	
	/**
	 * This method generates a Protocol Buffer Uconnect Message given the required inputs for vehicleLocationResponse.
	 * 
	 */
	public UconnectMessage getVehLocationRespMsg(VehicleLocationResponseEnum response,Location location) {
		this.messageId++;
		
		VehicleLocationResponse resp = VehicleLocationResponse.newBuilder()
			.setTimestamp(System.currentTimeMillis())
			.setResponse(response)
			.setVehicleLocation(location)
			.build();
    		
		UconnectMessage msg = UconnectMessage.newBuilder()
			.setTimestamp(System.currentTimeMillis())
			.setMessageId(messageId)
			.setCorrelationId(correlationId)
			.addMessages(UconnectAny.newBuilder().
			setExtension(GlobalUconnectExtVehicleFinder.vehicleLocationResponse, resp))
			.build();
		return msg;		
	}
	
	/**
	 * This method demonstrates connecting to the AWS IoT mqtt broker and publishing an StolenVehAsist messages to the VFND topic.
	 */
	public void process() {
		mqttClient = new AWSIotMqttClient("endpoint", clientId, "awsAccessKeyId", "awsSecretAccessKey");
		try {			
			mqttClient.connect();						
			iotTopic = new AWSIotTopic(clientId+"/VFND/", AWSIotQos.QOS1) {
	public void onMessage(AWSIotMessage msg) {
		try{
		UconnectMessage msgIn;
			msgIn = UconnectMessage.parseFrom(msg.getPayload(),extRegistry);
			correlationId=msgIn.getMessageId();
	if (msgIn.getMessages(0).hasExtension(GlobalUconnectExtVehicleFinder.vehicleLocationRequest)) {
		VehicleLocationRequest vehicleLocationRequest = msgIn.getMessages(0).getExtension(
				GlobalUconnectExtVehicleFinder.vehicleLocationRequest);
		correlationId = msgIn.getMessageId();
		Location vehLocation = Location.newBuilder()
				.setPositionLatitude(42.480201)
				.setPositionLongitude(-83.671875F)
				.build();
		sendMessage(getVehLocationRespMsg(VehicleLocationResponseEnum.SUCCESS,vehLocation));
	}
	} catch( Exception ex) {
		ex.printStackTrace();
		System.out.println("Err processing message: "+ex+", try parsing VehicleFinder messages.");
	}
 }
};
			mqttClient.subscribe(iotTopic);
		} catch (AWSIotException ex) {
			System.out.println("Caught AWS Exception "+ex);
			ex.printStackTrace();
		}  catch (Exception e) {
			e.printStackTrace();
		}
	}
	public void disconnect(){
		try {
			mqttClient.disconnect();
		} catch (AWSIotException e) {
			e.printStackTrace();
		}
	}	
	public void sendMessage(UconnectMessage msg) {
		final byte[] msgOut = msg.toByteArray();
		new Thread(new Runnable() {
		    @Override
		public void run() {
		try {						
			AWSIotMessage message = new 
					MessagePublisherListener("/VFND/"+clientId,AWSIotQos.QOS1,msgOut);
			mqttClient.publish(message);

		} catch (AWSIotException e) {
			System.out.println("Caught Exception "+e);
						e.printStackTrace();
					}		    	
			    }
			}).start();
		}
	
	/**
	 * Example main to launch example.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		TBMExampleForVehicleFinder example = new TBMExampleForVehicleFinder();
		example.process();
	}
}